import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * A beetle tries to avoid being trampled by elephants.
 * 
 * @author David J. Barnes
 * @version 2008.08.01
 */
public class Beetle extends MoveableActor
{
    /**
     * A beetle moves under the keyboard control of a user.
     */
    public void act() 
    {
        int x = getX(), y = getY();
        char movement = getMovementChar();
        
        if(movement == Movements.LEFT) {
            x--;
        }
        else if(movement == Movements.RIGHT) {
            x++;
        }
        else if(movement == Movements.UP) {
            y--;
        }
        else if(movement == Movements.DOWN) {
            y++;
        }
        else if(movement == Movements.TELEPORT) {
            x = Greenfoot.getRandomNumber(getWorld().getWidth());
            y = Greenfoot.getRandomNumber(getWorld().getHeight());
        }
        else {
            // Do nothing.
        }
        
        // Only move if the location is free.
        if(locationIsFree(x, y)) {
            setLocation(x, y);
        }
    }
    
    /**
     * Determine whether the given location is free or not.
     * @param x x-coordinate
     * @param y y-coordinate
     * @return true if the location is free, false otherwise.
     */
    private boolean locationIsFree(int x, int y)
    {
        List<Actor> actors = getWorld().getObjectsAt(x, y, Actor.class);
        actors.remove(this);
        return actors.size() == 0;
    }
}
